'Coded by UEZ build 2020-03-27
#include "string.bi"

#Define _Dist(x1, x2, y1, y2)	(((y2 - y1) * (y2 - y1) + (x2 - x1) * (x2 - x1)))
#Define _Round(x)    			((x + 0.5) Shr 0)

Declare Sub Motion()
Declare Function RandomRange(fStart As Single, fEnd As Single) As Single

Const As UShort iW = 1024, iH = 768
Const As ULong  iBGColor = &hFF000000

ScreenRes iW, iH, 32, 2, 100
ScreenSet 1, 0

Dim Shared As Any Ptr img, img_clr
img = Imagecreate(iW, iH, 0, 32)
img_clr = Imagecreate(iW, iH, iBGColor, 32)

Randomize , 5

Const iParticles = 19999, iPSize = 1, iMaxSickDays = 14, fDaySpeed = 0.0075, iDayInoFound = 21
Dim Shared As Uinteger iPSize2
iPSize2 = iPSize^2
Dim Shared As Single fDaysPassed = 0
Type vParticle
	Dim As Single x, y, vx, vy, sickdays, healthydays
	Dim As Ulong c
	Dim As Ubyte status, zone 'status: healthy = 0, infected = 1, cured = 2, dead = 3, inoculated = 4
End Type

Type vZone
	Dim As Ushort x1, y1, x2, y2
	Dim As Uinteger pp(iParticles + 1) 'index of particle
	Dim As Ulong c
End Type

Dim Shared As Ushort iZones = 2^8 - 1
Dim Shared As vZone Zones(iZones)
Dim As Uinteger i, j, cw, ch, seg
seg = Sqr(iZones + 1)
cw = _Round(iW / (iZones + 1)) * seg
ch = _Round(iH / (iZones + 1)) * seg
For i = 0 To iZones
	Zones(i).c = &h80000000 Or Culng(Rnd() * &hFFFFFF)
	Zones(i).x1 = (i Mod seg) * cw
	Zones(i).x2 = Zones(i).x1 + cw
	Zones(i).y1 = (i \ seg Mod seg) * ch
	Zones(i).y2 = Zones(i).y1 + ch
Next


Dim Shared As vParticle Particles(iParticles)
For i = 0 To iParticles
	Particles(i).x = RandomRange(iPSize + 1, iW - iPSize - 1)
	Particles(i).y = RandomRange(iPSize + 1, iH - iPSize - 1)
	Particles(i).c = &hFFFFFFFF
	Particles(i).vx = 0.5 * Rnd() - 0.25
	Particles(i).vy = 0.5 * Rnd() - 0.25
	Particles(i).status = 0
	Particles(i).sickdays = 0
	Particles(i).healthydays = 0
Next
i = Cuint(Rnd * iParticles) 'gunman aka patient zero
Particles(i).c = &hFFFF0000
Particles(i).status = 1
Particles(i).vx *= 5
Particles(i).vy *= 4

Dim As Ulong iFPS = 0, iFPS_current = 0
Dim As Double fTimer = Timer

Do
	Put img, (0, 0), img_clr, Pset
	Motion()
	Put (0, 0), img, Pset
	Draw String(1, 1), iFPS_current & " fps", Rgba(&hF0, &hF0, &h10, &hFF)
	Flip
	fDaysPassed += fDaySpeed
	If Timer - fTimer > 0.99 Then
		iFPS_current = iFPS
		iFPS = 0
		fTimer = Timer
	Else
		iFPS += 1
	End If
    Sleep 1, 1
Loop Until Len(InKey())

Imagedestroy(img_clr)
Imagedestroy(img)

Sub Motion()
	Dim As Uinteger i, j, k, l, iBucket, index, iHealthy = 0, iInfected = 0, iCured = 0, iDead = 0, iInoculated = 0
	For j = 0 To iZones 'reset amount if pixel in the bucket
		Zones(j).pp(0) = 0
		'Line img, (Zones(j).x1, Zones(j).y1)-(Zones(j).x2, Zones(j).y2), Zones(j).c, BF 'display zones for debugging
	Next
	For i = 0 To iParticles
		'move each pixel if not dead
		If Particles(i).status <> 3 Then 
			Particles(i).x += Particles(i).vx 
			Particles(i).y += Particles(i).vy
		End If
		'check border collision
		If Particles(i).x < 0 Or Particles(i).x > iW - iPSize - 1 Then Particles(i).vx *= -1
		If Particles(i).y < 0 Or Particles(i).y > iH - iPSize - 1 Then Particles(i).vy *= -1
		'group pixel into zones for collision check afterwards
		For j = 0 To iZones
			If Particles(i).x > Zones(j).x1 And Particles(i).x < Zones(j).x2 - iPSize And Particles(i).y > Zones(j).y1 And Particles(i).y < Zones(j).y2 - iPSize Then
				Zones(j).pp(0) += 1
				Zones(j).pp(Zones(j).pp(0)) = i
				'Particles(i).c = Zones(j).c
				Particles(i).zone = j
				Exit For
			End If
		Next
		
		If Particles(i).status = 0 Then Particles(i).healthydays += fDaySpeed
		If Particles(i).healthydays > iDayInoFound And Particles(i).status = 0 Then 'immunisation has been found -> inoculation started
			If Rnd() < 0.0015 Then Particles(i).status = 4 'add a delay as not each pixel will be incoculated at the same time
		End If
		
		If Particles(i).sickdays > iMaxSickDays Then
			Particles(i).sickdays = 0
			If Rnd() < 0.05 Then 'probability of death at 5%
				Particles(i).status = 3
				Particles(i).vx = 0
				Particles(i).vy = 0
			Else 'cured
				Particles(i).status = 2
			End If
		End If
		
		Select Case Particles(i).status
			Case 0
				iHealthy += 1
				Particles(i).c = &hFFFFFFFF
			Case 1
				Particles(i).sickdays += fDaySpeed
				iInfected += 1
				Particles(i).c = &hFFF00000
			Case 2
				iCured += 1
				Particles(i).c = &hFF00F000
			Case 3
				iDead += 1
				Particles(i).c = &hFFE238EC
			Case 4
				iInoculated += 1
				Particles(i).c = &hFF2020FF
		End Select
		Line img, (Particles(i).x, Particles(i).y)-(Particles(i).x + iPSize, Particles(i).y + iPSize), Particles(i).c, BF
	Next
	
	'collision check of infected pixels
	For i = 0 To iParticles		
		If Particles(i).status = 1 Then 'don't check dead and healty pixels		
			iBucket = Zones(Particles(i).zone).pp(0)
			For j = 1 To iBucket
				index = Zones(Particles(i).zone).pp(j)
				If Particles(index).status = 0 And index <> i Then
					If Int(_Dist(Particles(i).x, Particles(index).x, Particles(i).y, Particles(index).y)) <= iPSize2 Then
						Particles(index).status = 1
					End If
				End If
			Next
		End If
	Next
	Dim As Ushort iSum = iHealthy + iCured + iInoculated
	Windowtitle("Corona Infection Simulation by UEZ / h: " & iSum & ", inf: " & iInfected & Format(iInfected / (iParticles - iDead), " (0.00%)") & _
				", c: " & iCured & ", d: " & iDead & Format(iDead / (iParticles + 1), " (0.00%)") & _
				", ino: " & iInoculated & ", day: " & Format(fDaysPassed, "#"))
End Sub


Function RandomRange(fStart As Single, fEnd As Single) As Single
   Return Rnd() * (fEnd - fStart) + fStart
End Function